<template>
  <main>
    <mt-page-title>
      <h1 class="has-text-weight-bold is-size-3">Liste des messages</h1>
    </mt-page-title>

    <template v-if="nonLus.length > 0">
      <h3 class="has-text-grey is-size-5 column">{{ nonLus.length }} nouveaux messages</h3>
      <section class="columns is-multiline">
        <mt-visu-contact
          v-for="(contact, index) in nonLus"
          :key="`non-lu${index}`"
          :contact="contact"
          @lire-message="lireMessage"
          @traiter-message="traiterMessage"
        ></mt-visu-contact>
      </section>
    </template>

    <template v-if="nonTraites.length > 0">
      <h3 class=" has-text-grey is-size-5 column">{{ nonTraites.length }} messages non traités</h3>
      <section class="columns is-multiline">
        <mt-visu-contact
          v-for="(contact, index) in nonTraites"
          :key="`non-traite${index}`"
          :contact="contact"
          @traiter-message="traiterMessage"
        ></mt-visu-contact>
      </section>
    </template>

    <h3 class=" has-text-grey is-size-5 column">{{ total }} anciens messages</h3>
    <section class="columns is-multiline">
      <mt-visu-contact v-for="(contact, index) in contacts" :key="`old${index}`" :contact="contact"></mt-visu-contact>
    </section>

    <mt-modal-action type-delete :ouvert.sync="ouvertDelete" @action="supprimerContact(monContact)">
      Êtes-vous certain(e) de vouloir supprimer le message ?
    </mt-modal-action>
    <b-pagination
      :total="total"
      :current="pageCourante"
      :per-page="parPage"
      order="is-centered"
      aria-next-label="Messages suivante"
      aria-previous-label="Messages précedente"
      aria-page-label="Messages"
      aria-current-label="Page courante"
      @change="getContact"
    />
  </main>
</template>
<script>
import { DateTime } from 'luxon';
import MtPageTitle from '~/components/base/page-title/index';
import MtModalAction from '~/components/modal/mt-modal-action';
import MtVisuContact from '~/components/dashboard/contact/visu-contact';

export default {
  layout: 'dashboard',
  components: {
    MtVisuContact,
    MtPageTitle,
    MtModalAction,
  },
  data() {
    return {
      ouvertDelete: false,
      monContact: {},
    };
  },
  async asyncData({ $api }) {
    const pageCourante = 1;
    const parPage = 10;
    const [
      { content: contacts, totalElements: total, numberOfElements: nombrePageCourante },
      nonLus,
      nonTraites,
    ] = await Promise.all([
      $api.contact.old(pageCourante - 1, parPage),
      $api.contact.nonLus(),
      $api.contact.nonTraites(),
    ]);
    return {
      contacts,
      pageCourante,
      parPage,
      total,
      nombrePageCourante,
      nonLus,
      nonTraites,
    };
  },
  methods: {
    async getContact(page) {
      this.pageCourante = page;
      [
        { content: this.contacts, totalElements: this.total, numberOfElements: this.nombrePageCourante },
        this.nonLus,
        this.nonTraites,
      ] = await Promise.all([
        this.$api.contact.old(this.pageCourante - 1, this.parPage),
        this.$api.contact.nonLus(),
        this.$api.contact.nonTraites(),
      ]);
    },
    dateFormat(date) {
      return DateTime.fromJSDate(date)
        .setLocale('fr')
        .toFormat('dd/MM/yyyy HH:mm');
    },
    confirmeSupprimer(contact) {
      this.ouvertDelete = true;
      this.monContact = contact;
    },
    async lireMessage(contact) {
      await this.$api.contact.lire(contact.id);
      await this.getContact(this.pageCourante);
    },
    async traiterMessage(contact) {
      await this.$api.contact.traiter(contact.id);
      await this.getContact(this.pageCourante);
    },
  },
};
</script>

<style scoped lang="scss"></style>
